// Copyright 2023 The Gitea Authors and MarketAlly. All rights reserved.
// SPDX-License-Identifier: MIT

package templates

import (
	"fmt"
	"reflect"
)

type SliceUtils struct{}

func NewSliceUtils() *SliceUtils {
	return &SliceUtils{}
}

func (su *SliceUtils) Contains(s, v any) bool {
	if s == nil {
		return false
	}
	sv := reflect.ValueOf(s)
	if sv.Kind() != reflect.Slice && sv.Kind() != reflect.Array {
		panic(fmt.Sprintf("invalid type, expected slice or array, but got: %T", s))
	}
	for i := 0; i < sv.Len(); i++ {
		it := sv.Index(i)
		if !it.CanInterface() {
			continue
		}
		if it.Interface() == v {
			return true
		}
	}
	return false
}

// Append appends an element to a slice and returns the new slice
func (su *SliceUtils) Append(s, v any) any {
	if s == nil {
		return []any{v}
	}
	sv := reflect.ValueOf(s)
	if sv.Kind() != reflect.Slice {
		panic(fmt.Sprintf("invalid type, expected slice, but got: %T", s))
	}
	// Create a new slice with the appended element
	newSlice := reflect.Append(sv, reflect.ValueOf(v))
	return newSlice.Interface()
}
